package de.markus.kaeppeler;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.BufferStrategy;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.border.Border;
import javax.swing.text.AbstractDocument.BranchElement;

public class Frame extends JFrame{
	
	Menu menu;
	GameScreen gS;
	BreakMenu breakMenu;
	JLabel distanceScore;
	JLabel coinScore;
	JLabel timeScore;
	
	Border b1;
	Font schrift1;
	Font schrift2;
	Image img;
	Color c1 = new Color(212, 68, 29);
	
	Frame(){
		addKeyListener(new KeyHandler());
		addMouseListener(new MouseHandler());
		addWindowListener(new WindowHandler());
		
		b1 = BorderFactory.createMatteBorder(2, 5, 2, 5, Color.BLACK);
		schrift1 = new Font("Cooper Black", Font.BOLD ,35);
		schrift2 = new Font("Cooper Black", Font.BOLD ,24);
		
		java.net.URL iconUrl = Frame.class.getResource("/pictures/LogoLittle.png");
		img = getToolkit().getImage(iconUrl);
		setIconImage(img);
		setLayout(null);
		setTitle("Flyvery by Markus Kppeler [MAEK], made for LD#29, Theme: Beneath the Surface");
		
		menu = new Menu();
		add(menu);
		
		breakMenu = new BreakMenu();
		breakMenu.setVisible(false);
		add(breakMenu);
		
		distanceScore = new JLabel("Distance");
		distanceScore.setBounds(700, 10, 200, 40);
		distanceScore.setFont(schrift2);
		distanceScore.setForeground(c1);
		add(distanceScore);
		
		coinScore = new JLabel("Coins");
		coinScore.setBounds(10, 10, 200, 40);
		coinScore.setFont(schrift1);
		coinScore.setForeground(c1);
		add(coinScore);
		
		timeScore = new JLabel("Time");
		timeScore.setBounds(380, 0, 200, 25);
		timeScore.setFont(schrift2);
		timeScore.setForeground(c1);
		add(timeScore);
		
		gS = new GameScreen();
		gS.setBounds(0, 0, 800, 500);
		add(gS);
	}

	public void updateall() {
		distanceScore.setText(String.format("%s m", Rechner.pixelDistance/100));
		coinScore.setText(String.format("%s $", Rechner.collectedCoins));
		timeScore.setText(String.format("%s s", Rechner.timeSinceStart/1000));
		gS.repaint();
		if(Rechner.stopGame){
			breakMenu.setAni();
		}
		
	}
	
	private class WindowHandler implements WindowListener{

		@Override
		public void windowActivated(WindowEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void windowClosed(WindowEvent e) {
			Highscore.Save();
			System.exit(0);
			
		}

		@Override
		public void windowClosing(WindowEvent e) {
			Highscore.Save();
			System.exit(0);
			
		}

		@Override
		public void windowDeactivated(WindowEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void windowDeiconified(WindowEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void windowIconified(WindowEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void windowOpened(WindowEvent e) {
			// TODO Auto-generated method stub
			
		}
		
	}

}
