package de.markus.kaeppeler;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.nio.Buffer;

import javax.imageio.ImageIO;
import javax.swing.JLabel;

public class GameScreen extends JLabel{
	
	Graphics2D g2d;
	BufferedImage airplane;
	BufferedImage airplaneBroken;
	BufferedImage backgroundDefault;
	BufferedImage shader;
	BufferedImage ventilator;
	BufferedImage airplaneBot;
	BufferedImage airplaneBot1;
	BufferedImage airplaneBot2;
	BufferedImage airplaneBot3;
	BufferedImage bullet;
	BufferedImage coin;
	BufferedImage distanceScore;
	BufferedImage coinScore;
	BufferedImage timeScore;
	Color c1 = new Color(212, 68, 29);
	
	GameScreen(){
		try {
			airplane = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/Airplane.png"));
			airplaneBroken = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/AirplaneBroken.png"));
			airplaneBot = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/AirplaneBot.png"));
			airplaneBot1 = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/AirplaneBot1.png"));
			airplaneBot2 = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/AirplaneBot2.png"));
			airplaneBot3 = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/AirplaneBot3.png"));
			backgroundDefault = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/BackgroundDefault.png"));
			shader = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/Shader.png"));
			ventilator = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/Ventilator.png"));
			bullet = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/Bullet.png"));
			coin = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/Coin.png"));
			distanceScore = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/DistanceScore.png"));
			coinScore = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/CoinScore.png"));
			timeScore = ImageIO.read(GameScreen.class.getClassLoader().getResourceAsStream("pictures/TimeScore.png"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		g2d = (Graphics2D) g;
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g.drawImage(backgroundDefault, Background.background1_pos_x, -20, null);
		g.drawImage(backgroundDefault, Background.background2_pos_x, -20, null);
		
		for(short i = (short) (ObjectManager.ventialtors.size()-1); i>=0; i--){
			g.drawImage(ventilator, ObjectManager.ventialtors.get(i).pos_x, 37, null);
		}
		
		g.drawImage(shader, 0, 37, null);
		
		for(short i = (short) (ObjectManager.airplaneBots.size()-1); i>=0; i--){
			switch(ObjectManager.airplaneBots.get(i).typ){
			case 0:
				g.drawImage(airplaneBot, ObjectManager.airplaneBots.get(i).pos_x, ObjectManager.airplaneBots.get(i).pos_y, null);
				break;
			case 1:
				g.drawImage(airplaneBot1, ObjectManager.airplaneBots.get(i).pos_x, ObjectManager.airplaneBots.get(i).pos_y, null);
				break;
			case 2:
				g.drawImage(airplaneBot2, ObjectManager.airplaneBots.get(i).pos_x, ObjectManager.airplaneBots.get(i).pos_y, null);
				break;
			case 3:
				g.drawImage(airplaneBot3, ObjectManager.airplaneBots.get(i).pos_x, ObjectManager.airplaneBots.get(i).pos_y, null);
				break;
			}
		}
		
		if(Airplane.broken){
			g.drawImage(airplaneBroken, Airplane.pos_x, Airplane.pos_y, null);
		}else{
			g.drawImage(airplane, Airplane.pos_x, Airplane.pos_y, null);
		}
		
		for(short i = (short) (ShotManager.bullets.size()-1); i>=0; i--){
			g.drawImage(bullet, ShotManager.bullets.get(i).pos_x, ShotManager.bullets.get(i).pos_y, null);
		}
		
		for(short i = (short) (ObjectManager.coins.size()-1); i>=0; i--){
			g.drawImage(coin, ObjectManager.coins.get(i).pos_x, ObjectManager.coins.get(i).pos_y, null);
			//g.fillRect(ObjectManager.coins.get(i).pos_x, ObjectManager.coins.get(i).pos_y, 10, 10);
		}
		
		g.setColor(c1);
		g.fillRect(0, 448, (int) (Rechner.speed * 60), 10);
		
		g.drawImage(distanceScore, 645, 0, null);
		g.drawImage(coinScore, 0, 0, null);
		g.drawImage(timeScore, 325, 0, null);
		
		super.paintComponent(g);
	}
}
