package de.markus.kaeppeler;
public class Main {
	public static void main(String[] args) {
		Frame f = new Frame();
		Rechner r = new Rechner();
		Airplane a = new Airplane();
		Background b = new Background();
		ObjectManager o = new ObjectManager();
		ShotManager s = new ShotManager();
		Highscore h = new Highscore();
		
		//Definieren des JFrames
		f.setSize(800, 500);
		f.setVisible(true);
		f.setResizable(false);			
		f.setLocationRelativeTo(null);
		f.setDefaultCloseOperation(f.EXIT_ON_CLOSE);
		
		//Frame
		double lastFrame = System.currentTimeMillis();
		double thisFrame;
		double timeSinceLastFrame;
		Rechner.setTimeStart();
		while(true){
			thisFrame = System.currentTimeMillis();
			timeSinceLastFrame = (thisFrame-lastFrame)/150;
			lastFrame=thisFrame;				
			r.setTimeSLF(timeSinceLastFrame);
			
			if(Rechner.gameRunning){
				Rechner.updateDistance();
				Rechner.updatePixelTime();
				Rechner.updateTimeSinceStart();
				Rechner.updateSpeed();
				a.update();
				Background.update();
				ObjectManager.update();
				s.update();
				f.updateall();
			}
			f.menu.highscore.setText(String.format("Highscore: %s", Highscore.highscore));
			f.breakMenu.aniUpdate();
			if(Rechner.stopGame){
				Rechner.gameRunning = false;
				Rechner.stopGame = false;
			}
			if(Rechner.pauseGame){
				Rechner.gameRunning = false;
				f.breakMenu.setVisible(false);
				f.menu.setVisible(true);
				Rechner.pauseGame = false;
			}
			
			try {
				Thread.sleep(15);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

}
