package de.markus.kaeppeler;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;

public class Menu extends JPanel{
	
	JButton play;
	Icon playBD;
	Icon playBR;
	JLabel highscore;
	JButton tuning;
	Icon tuningBD;
	Icon tuningBR;
	JButton quit;
	Icon quitBD;
	Icon quitBR;
	JLabel backgroundJL;
	Icon background;
	
	JLabel coins;
	Icon backgroundTuning;
	JLabel[] tuningLevel;
	JButton[] tuningUp;
	Icon tuningUpBD;
	Icon tuningUpBR;
	Icon tuningUpMaxSpeedBD;
	Icon tuningUpMaxSpeedBR;
	Icon tuningUpAccelerationBD;
	Icon tuningUpAccelerationBR;
	Icon tuningUpBrakesBD;
	Icon tuningUpBrakesBR;
	
	JButton backToMenuJB;
	Icon backToMenuBD;
	Icon backToMenuBR;
	
	Font schrift1;
	Font schrift2;
	Border b2;
	
	Menu(){
		schrift1 = new Font("Cooper Black", Font.CENTER_BASELINE ,50);
		schrift2 = new Font("Cooper Black", Font.CENTER_BASELINE ,22);
		setBounds(0, 0, 800, 500);
		setLayout(null);
		setBackground(Color.WHITE);
		
		b2 = BorderFactory.createMatteBorder(0, 0, 0, 0, Color.WHITE);
		
		playBD = new ImageIcon(Menu.class.getResource("/pictures/ButtonPlay.png"));
		playBR = new ImageIcon(Menu.class.getResource("/pictures/ButtonPlayRollover.png"));
		play = new JButton(playBD);
		play.setBounds(36, 30, 400, 50);
		play.setVisible(true);
		play.setEnabled(true);
		play.setContentAreaFilled(false);
		play.setFocusable(false);
		play.setBorder(b2);
		play.setRolloverIcon(playBR);
		add(play);
		play.addActionListener(new PlayHandler());
		
		tuningBD = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuning.png"));
		tuningBR = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuningRollover.png"));
		tuning = new JButton(tuningBD);
		tuning.setBounds(36, 90, 400, 50);
		tuning.setVisible(true);
		tuning.setEnabled(true);
		tuning.setContentAreaFilled(false);
		tuning.setFocusable(false);
		tuning.setBorder(b2);
		tuning.setRolloverIcon(tuningBR);
		add(tuning);
		tuning.addActionListener(new TuningHandler());
		
		quitBD = new ImageIcon(Menu.class.getResource("/pictures/ButtonQuit.png"));
		quitBR = new ImageIcon(Menu.class.getResource("/pictures/ButtonQuitRollover.png"));
		quit = new JButton(quitBD);
		quit.setBounds(36, 150, 400, 50);
		quit.setVisible(true);
		quit.setEnabled(true);
		quit.setContentAreaFilled(false);
		quit.setFocusable(false);
		quit.setBorder(b2);
		quit.setRolloverIcon(quitBR);
		add(quit);
		quit.addActionListener(new QuitHandler());
		
		highscore = new JLabel(String.format("Highscore: %s", Highscore.highscore));
		highscore.setBounds(550, 200, 300, 50);
		highscore.setFont(schrift2);
		add(highscore);
		
		coins = new JLabel("$");
		coins.setBounds(40, 100, 400, 50);
		coins.setForeground(Color.WHITE);
		coins.setFont(schrift1);
		coins.setVisible(false);
		add(coins);
		
		tuningUpBD = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuningUp.png"));
		tuningUpBR = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuningUpRollover.png"));
		tuningUpMaxSpeedBD = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuningUpMaxSpeed.png"));
		tuningUpMaxSpeedBR = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuningUpMaxSpeedRollover.png"));
		tuningUpAccelerationBD = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuningUpAcceleration.png"));
		tuningUpAccelerationBR = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuningUpAccelerationRollover.png"));
		tuningUpBrakesBD = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuningUpBrake.png"));
		tuningUpBrakesBR = new ImageIcon(Menu.class.getResource("/pictures/ButtonTuningUpBrakeRollover.png"));
		tuningUp = new JButton[3];
		for(int i = tuningUp.length-1; i>=0; i--){
			switch(i){
			case 0:
				tuningUp[i] = new JButton(tuningUpMaxSpeedBD);
				tuningUp[i].setRolloverIcon(tuningUpMaxSpeedBR);
				break;
			case 1:
				tuningUp[i] = new JButton(tuningUpAccelerationBD);
				tuningUp[i].setRolloverIcon(tuningUpAccelerationBR);
				break;
			case 2:
				tuningUp[i] = new JButton(tuningUpBrakesBD);
				tuningUp[i].setRolloverIcon(tuningUpBrakesBR);
				break;
			case 3:
				tuningUp[i] = new JButton(tuningUpBD);
				tuningUp[i].setRolloverIcon(tuningUpBR);
				break;
			}
			tuningUp[i].setBounds(260, (i*50)+125, 180, 40);
			tuningUp[i].setVisible(false);
			tuningUp[i].setEnabled(false);
			tuningUp[i].setContentAreaFilled(false);
			tuningUp[i].setFocusable(false);
			tuningUp[i].setBorder(b2);
			add(tuningUp[i]);
			tuningUp[i].addActionListener(new TuningHandler());
		}
		
		tuningLevel = new JLabel[4];
		for(int i = tuningLevel.length-1; i>=0; i--){
			tuningLevel[i] = new JLabel("Level: 1");
			tuningLevel[i].setBounds(450, (i*50)+125, 200, 40);
			tuningLevel[i].setForeground(Color.BLACK);
			tuningLevel[i].setFont(schrift2);
			tuningLevel[i].setVisible(false);
			add(tuningLevel[i]);
		}
		
		backToMenuBD = new ImageIcon(Menu.class.getResource("/pictures/BackToMenu.png"));
		backToMenuBR = new ImageIcon(Menu.class.getResource("/pictures/BackToMenuRollover.png"));
		backToMenuJB = new JButton(backToMenuBD);
		backToMenuJB.setBounds(600, 370, 100, 100);
		backToMenuJB.setVisible(false);
		backToMenuJB.setEnabled(false);
		backToMenuJB.setContentAreaFilled(false);
		backToMenuJB.setFocusable(false);
		backToMenuJB.setBorder(b2);
		backToMenuJB.setRolloverIcon(backToMenuBR);
		add(backToMenuJB);
		backToMenuJB.addActionListener(new QuitHandler());
		
		background = new ImageIcon(Menu.class.getResource("/pictures/MenuBackground.png"));
		backgroundJL = new JLabel(background);
		backgroundJL.setBounds(0, 0, background.getIconWidth(), background.getIconHeight());
		add(backgroundJL);
		
		backgroundTuning = new ImageIcon(Menu.class.getResource("/pictures/BackgroundTuning.png"));
	}
	
	private void updateLevel(){
		for(int i = tuningLevel.length-1; i>=0; i--){
			switch(i){
			case 0:
				tuningLevel[i].setText(String.format("Level: %s", Rechner.maxSpeed-7));
				break;
			case 1:
				tuningLevel[i].setText(String.format("Level: %s", Rechner.aPlus));
				break;
			case 2:
				tuningLevel[i].setText(String.format("Level: %s", Rechner.aMinus-2));
				break;
			case 3:
				tuningLevel[i].setText(String.format(""));
				break;
			}
		}
	}
	
	private void loadMenu(){
		play.setVisible(true);
		play.setEnabled(true);
		tuning.setVisible(true);
		tuning.setEnabled(true);
		quit.setVisible(true);
		quit.setEnabled(true);
		highscore.setVisible(true);
		for(int i = tuningUp.length-1; i>=0; i--){
			tuningUp[i].setVisible(false);
			tuningUp[i].setEnabled(false);
		}
		for(int i = tuningLevel.length-1; i>=0; i--){
			tuningLevel[i].setVisible(false);
		}
		coins.setVisible(false);
		backToMenuJB.setVisible(false);
		backToMenuJB.setEnabled(false);
		backgroundJL.setIcon(background);
	}
	
	private void loadTuningMenu(){
		play.setVisible(false);
		play.setEnabled(false);
		tuning.setVisible(false);
		tuning.setEnabled(false);
		quit.setVisible(false);
		quit.setEnabled(false);
		highscore.setVisible(false);
		for(int i = tuningUp.length-1; i>=0; i--){
			tuningUp[i].setVisible(true);
			tuningUp[i].setEnabled(true);
		}
		updateLevel();
		for(int i = tuningLevel.length-1; i>=0; i--){
			tuningLevel[i].setVisible(true);
		}
		coins.setText(String.format("%s $", Rechner.coins));
		coins.setVisible(true);
		backToMenuJB.setVisible(true);
		backToMenuJB.setEnabled(true);
		backgroundJL.setIcon(backgroundTuning);
	}
	
	private class PlayHandler implements ActionListener{

		@Override
		public void actionPerformed(ActionEvent arg0) {
			setVisible(false);
			Rechner.gameRunning = true;
		}
		
	}
	
	private class QuitHandler implements ActionListener{

		@Override
		public void actionPerformed(ActionEvent e) {
			if(e.getSource() == quit){
				Highscore.Save();
				System.exit(0);
			}
			if(e.getSource() == backToMenuJB){
				loadMenu();
			}
		}
		
	}
	
	private class TuningHandler implements ActionListener{

		@Override
		public void actionPerformed(ActionEvent e) {
			if(e.getSource() == tuning){
				loadTuningMenu();
			}
			if(e.getSource() == tuningUp[0]){
				if(Rechner.coins>=20 && Rechner.maxSpeed<15){
					Rechner.coins -= 20;
					Rechner.maxSpeed++;
					coins.setText(String.format("%s $", Rechner.coins));
					updateLevel();
				}
			}
			if(e.getSource() == tuningUp[1]){
				if(Rechner.coins>=50 && Rechner.aPlus<3){
					Rechner.coins -= 50;
					Rechner.aPlus++;
					coins.setText(String.format("%s $", Rechner.coins));
					updateLevel();
				}
			}
			if(e.getSource() == tuningUp[2]){
				if(Rechner.coins>=50 && Rechner.aMinus<5){
					Rechner.coins -= 50;
					Rechner.aMinus++;
					coins.setText(String.format("%s $", Rechner.coins));
					updateLevel();
				}
			}
		}
		
	}
	
}
