package de.markus.kaeppeler;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class ObjectManager {
	
	static Random r;
	
	static List <Ventilator> ventialtors;
	static List <AirplaneBot> airplaneBots;
	static List <Coin> coins;
	
	ObjectManager(){
		r = new Random();
		ventialtors = new ArrayList<Ventilator>();
		airplaneBots = new ArrayList<AirplaneBot>();
		coins = new ArrayList<Coin>();
	}
	
	static void update(){
		updateGen();
		updatePos();
	}
	
	private static void updatePos() {
		updateVentilatorPos();
		updateAirplaneBotPos();
		updateCoinPos();
	}

	private static void updateGen(){
		updateVentilatorGen();
		updateAirplaneBotGen();
	}
	
	private static void updateCoinPos(){
		for(short i = (short) (coins.size()-1); i>=0; i--){
			coins.get(i).update();
			if(coins.get(i).pos_x < -90){
				coins.remove(i);
			}
		}
	}
	
	public static void newCoins(int pos_x, int pos_y, int number){
		for(int i = number; i>0; i--){
			coins.add(new Coin(pos_x+i*25, pos_y));
		}
	}
	
	private static void updateAirplaneBotGen(){
		if(Rechner.pixelDistance/100 > 0 && Rechner.pixelDistance/100 < 50){
			if(Rechner.oneHundertPixels && r.nextInt(7) == 1){
				airplaneBots.add(new AirplaneBot(r.nextInt(358)+55, r.nextInt(5)+1, r.nextInt(2)));
			}
		}
		if(Rechner.pixelDistance/100 > 50 && Rechner.pixelDistance/100 < 100){
			if(Rechner.oneHundertPixels && r.nextInt(6) == 1){
				airplaneBots.add(new AirplaneBot(r.nextInt(358)+55, r.nextInt(5)+1, r.nextInt(2)));
			}
		}
		if(Rechner.pixelDistance/100 > 100 && Rechner.pixelDistance/100 < 200){
			if(Rechner.oneHundertPixels && r.nextInt(5) == 1){
				airplaneBots.add(new AirplaneBot(r.nextInt(358)+55, r.nextInt(5)+1, r.nextInt(2)));
			}
		}
		if(Rechner.pixelDistance/100 > 200 && Rechner.pixelDistance/100 < 300){
			if(Rechner.oneHundertPixels && r.nextInt(4) == 1){
				airplaneBots.add(new AirplaneBot(r.nextInt(358)+55, r.nextInt(5)+1, r.nextInt(2)));
			}
		}
		if(Rechner.pixelDistance/100 > 300 && Rechner.pixelDistance/100 < 600){
			if(Rechner.oneHundertPixels && r.nextInt(3) == 1){
				airplaneBots.add(new AirplaneBot(r.nextInt(358)+55, r.nextInt(5)+1, r.nextInt(2)));
			}
		}
		if(Rechner.pixelDistance/100 > 600 && Rechner.pixelDistance/100 < 1000){
			if(Rechner.oneHundertPixels && r.nextInt(2) == 1){
				airplaneBots.add(new AirplaneBot(r.nextInt(358)+55, r.nextInt(5)+1, r.nextInt(2)));
			}
		}
		if(Rechner.pixelDistance/100 > 1000){
			if(Rechner.oneHundertPixels){
				airplaneBots.add(new AirplaneBot(r.nextInt(358)+55, r.nextInt(5)+1, r.nextInt(2)));
			}
		}
		
	}
	
	private static void updateAirplaneBotPos(){
		for(short i = (short) (airplaneBots.size()-1); i>=0; i--){
			airplaneBots.get(i).update();
			if(airplaneBots.get(i).pos_x < -90 || airplaneBots.get(i).pos_y > 490){
				airplaneBots.remove(i);
			}
		}
	}
	
	private static void updateVentilatorGen(){
		if(Rechner.oneHundertPixels && r.nextInt(3) == 1){
			ventialtors.add(new Ventilator());
		}
	}
	
	private static void updateVentilatorPos(){
		for(short i = (short) (ventialtors.size()-1); i>=0; i--){
			ventialtors.get(i).update();
			if(ventialtors.get(i).pos_x < -90){
				ventialtors.remove(i);
			}
		}
	}

}
